import os, sys, string
import Numeric as num


def ReadArray(filename):
    dataList = []
    infile = open(filename)
    nextLine = infile.readline()
    assert nextLine.startswith("#")
    metaData = string.split(nextLine)
    for item in metaData[1:]: # ignore initial "#"
        key,val = string.split(item,"=")
        if key=="Dt":
            Dt = string.atof(val)
    nextLine = infile.readline()
    while nextLine:
        while nextLine.startswith("#") or nextLine.startswith("@"):
            nextLine = infile.readline()
        items = map(string.atof, string.split(nextLine))
        dataList.append(items)
        nextLine = infile.readline()

    return num.array(dataList), Dt

def GetVariance(data):
    dev = data-num.average(data)
    return num.sum(dev**2)/(len(data)-1.)

def GetCovariance(data1, data2):
    assert len(data1) == len(data2)
    dev1 = data1 - num.average(data1)
    dev2 = data2 - num.average(data2)
    return num.sum(dev1*dev2)/(len(data1)-1.)

outfile = open("stdE_vs_dt.dat","w")
outfile.write("# filename, dt, variance, corrected variance, drift rate\n")

fileList = os.listdir(".")
fileList.sort()
#dtList = [0.0001, 0.0002, 0.0004, 0.0008, 0.0016, 0.0032, 0.0064]
#Dt = 2.56 # 0.0128
for filename in fileList:
    if not filename.startswith("energies"):
        continue
    
    dt = string.atof(filename[-10:-4])
    energies, Dt = ReadArray(filename)
    #print "Dt=",Dt
    Etot = energies[:,5]
    varE = GetVariance(Etot)
    stdE = num.sqrt(varE)

    times = num.array(range(len(Etot)))*Dt
    varT = GetVariance(times)
    covarET = GetCovariance(Etot, times)
    drift = covarET/varT
    stdEminusDrift = num.sqrt(varE-covarET**2/varT)
    outfile.write("%s %f %g %g %g\n" % (filename, dt, stdE, stdEminusDrift, drift))
