#include "rumd/AlternatePotentialCalculator.h"
#include "rumd/Sample.h"
#include "rumd/Potential.h"

AlternatePotentialCalculator::AlternatePotentialCalculator(Sample* S, Potential* alt_pot) : mainSample(S), myPotential(alt_pot) {

  mySample = new Sample(*mainSample);
  mySample->SetVerbose(false);
  mySample->SetPotential(myPotential);
}


AlternatePotentialCalculator::~AlternatePotentialCalculator() {
  delete mySample;
}

void AlternatePotentialCalculator::GetDataInfo(std::map<std::string, bool> &writingItem, std::map<std::string, std::string> &columnIDs) {
  writingItem[myPotential->GetID_String()] = true;
  columnIDs[myPotential->GetID_String()] = myPotential->GetID_String();

  writingItem[myPotential->GetID_String() + "_W"] = true;
  columnIDs[myPotential->GetID_String() + "_W"] = myPotential->GetID_String() + "_W";
}

void AlternatePotentialCalculator::RemoveDataInfo(std::map<std::string, bool> &writingItem, std::map<std::string, std::string> &columnIDs) {
  writingItem.erase(myPotential->GetID_String());
  columnIDs.erase(myPotential->GetID_String());
}

void AlternatePotentialCalculator::GetDataValues(std::map<std::string, float> &dataValues) {
  
  (*mySample) = (*mainSample); // copies the data
  
  mySample->CalcF();

  dataValues[myPotential->GetID_String()] = mySample->GetPotentialEnergy()/mySample->GetNumberOfParticles();

  dataValues[myPotential->GetID_String() + "_W"] = mySample->GetVirial()/mySample->GetNumberOfParticles();

}
